﻿using System.Collections;
namespace Visitor.Ejm1
{
    /// <summary>
    /// La clase OrderVisitor es un implementador de la interface VisitorInterface, 
    /// que se encarga de calcular la suma de todos los pedidos
    /// </summary>
    public class OrderVisitor : VisitorInterface
    {

        private ArrayList OrderObjList;
        private double OrderTotal;

        public OrderVisitor()
        {
            OrderObjList = new ArrayList();
        }

        public void Visit(NonCaliforniaOrder inp_order)
        {
            OrderTotal = OrderTotal + inp_order.GetOrderAmount();
        }

        public void Visit(CaliforniaOrder inp_order)
        {
            OrderTotal = OrderTotal + inp_order.GetOrderAmount()
                    + inp_order.GetAdditionalTax();
        }

        public void Visit(OverseasOrder inp_order)
        {
            OrderTotal = OrderTotal + inp_order.GetOrderAmount()
                    + inp_order.getAdditionalSH();
        }

        public double GetOrderTotal()
        {
            return OrderTotal;
        }
    }

}
