﻿using System;
using Visitor.Ejm1;
namespace Visitor
{
    class Program
    {
        static void Main(string[] args)
        {
            // CREAR LA ORDEN

            // get input values
            string orderType = "CALIFORNIA"; //Puede ser tambien: NON-CALIFORNIA, OVERSEAS
            double dblOrderAmount = 1000;
            double dblTax = 10;
            double dblSH = 2.0;

            // Create the order
            Order order = createOrder(orderType, dblOrderAmount, dblTax, dblSH);
            // Get the Visitor
            OrderVisitor visitor = new OrderVisitor();
            // accept the visitor instance
            order.Accept(visitor);
            Console.WriteLine("Order Created Successfully");

            // OBTENER EL TOTAL
            double totalResult = visitor.GetOrderTotal();
            Console.WriteLine(" Orders Total = " + totalResult);

            //------------------OTRO PEDIDO--------------------------

            orderType = "NON-CALIFORNIA"; //Puede ser tambien: NON-CALIFORNIA, OVERSEAS
            dblOrderAmount = 5000;
            dblTax = 5.0;
            dblSH = 12.0;

            // Create the order
            order = createOrder(orderType, dblOrderAmount, dblTax, dblSH);

            // accept the visitor instance
            order.Accept(visitor);
            Console.WriteLine("Order Created Successfully");

            // OBTENER EL TOTAL
             totalResult = visitor.GetOrderTotal();
            Console.WriteLine(" Orders Total = " + totalResult);

            //------------------OTRO PEDIDO--------------------------

            orderType = "OVERSEAS"; //Puede ser tambien: NON-CALIFORNIA, OVERSEAS
            dblOrderAmount = 5000;
            dblTax = 5.0;
            dblSH = 12.0;

            // Create the order
            order = createOrder(orderType, dblOrderAmount, dblTax, dblSH);

            // accept the visitor instance
            order.Accept(visitor);
            Console.WriteLine("Order Created Successfully");

            // OBTENER EL TOTAL
            totalResult = visitor.GetOrderTotal();
            Console.WriteLine(" Orders Total = " + totalResult);

            Console.ReadKey();
        }

        public static Order createOrder(string orderType, double orderAmount,
                double tax, double SH)
        {
            if (orderType.Equals("CALIFORNIA"))
            {
                return new CaliforniaOrder(orderAmount, tax);
            }
            if (orderType.Equals("NON-CALIFORNIA"))
            {
                return new NonCaliforniaOrder(orderAmount);
            }
            if (orderType.Equals("OVERSEAS"))
            {
                return new OverseasOrder(orderAmount, SH);
            }
            return null;
        }
    }
}
